Index: /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3346)
+++ /palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 3347)
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! - Revise structure of init routine
+! - introduce new parameters to skip STG for some timesteps
+! - introduce time-dependent parametrization of Reynolds-stress tensor
+! - Bugfix in allocation of mean_inflow_profiles
+! 
+! 3341 2018-10-15 10:31:27Z suehring
 ! Introduce module parameter for number of inflow profiles
 ! 
@@ -122,5 +128,6 @@
 ! Authors:
 ! --------
-! @author Tobias Gronemeier, Atsushi Inagaki, Micha Gryschka, Christoph Knigge
+! @author Tobias Gronemeier, Matthias Suehring, Atsushi Inagaki, Micha Gryschka, Christoph Knigge
+! 
 !
 !
@@ -133,5 +140,6 @@
 !> a time scale for each velocity component. The profiles of length and time
 !> scales, mean u, v, w, e and pt, and all components of the Reynolds stress
-!> tensor are read from file STG_PROFILES.
+!> tensor can be either read from file STG_PROFILES, or will be parametrized
+!> within the boundary layer. 
 !>
 !> @todo test restart
@@ -149,8 +157,8 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  mean_inflow_profiles, u, v, w
+        ONLY:  mean_inflow_profiles, q, pt, u, v, w, zu, zw
 
     USE basic_constants_and_equations_mod,                                     &
-        ONLY:  pi
+        ONLY:  g, kappa, pi
 
     USE control_parameters,                                                    &
@@ -159,5 +167,5 @@
 
     USE cpulog,                                                                &
-        ONLY:  cpu_log, log_point, log_point_s
+        ONLY:  cpu_log, log_point
 
     USE indices,                                                               &
@@ -170,4 +178,7 @@
 #endif
 
+    USE nesting_offl_mod,                                                      &
+        ONLY:  zi_ribulk
+
     USE pegrid,                                                                &
         ONLY:  comm1dx, comm1dy, comm2d, ierr, myidx, myidy, pdims
@@ -184,6 +195,7 @@
 
 
-    LOGICAL :: velocity_seed_initialized = .FALSE.  !< true after first call of stg_main
-    LOGICAL :: use_syn_turb_gen = .FALSE.           !< switch to use synthetic turbulence generator
+    LOGICAL ::  velocity_seed_initialized = .FALSE.     !< true after first call of stg_main
+    LOGICAL ::  parametrize_inflow_turbulence = .FALSE. !< flag indicating that inflow turbulence is either read from file (.FALSE.) or if it parametrized
+    LOGICAL ::  use_syn_turb_gen = .FALSE.              !< switch to use synthetic turbulence generator
 
     INTEGER(iwp) ::  id_stg_left        !< left lateral boundary core id in case of turbulence generator
@@ -202,57 +214,79 @@
     INTEGER(iwp) ::  nzt_y_stg          !< upper bound of z coordinate (required for transposing z on PEs along y)
 
-    REAL(wp) :: mc_factor    !< mass flux correction factor
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: displs_xz      !< displacement for MPI_GATHERV
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: recv_count_xz  !< receive count for MPI_GATHERV
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: displs_yz      !< displacement for MPI_GATHERV
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: recv_count_yz  !< receive count for MPI_GATHERV
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nux            !< length scale of u in x direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nuy            !< length scale of u in y direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nuz            !< length scale of u in z direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nvx            !< length scale of v in x direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nvy            !< length scale of v in y direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nvz            !< length scale of v in z direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nwx            !< length scale of w in x direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nwy            !< length scale of w in y direction (in gp)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: nwz            !< length scale of w in z direction (in gp)
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE :: seed        !< seed of random number for rn-generator
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: a11             !< coefficient for Lund rotation
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: a21             !< coefficient for Lund rotation
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: a22             !< coefficient for Lund rotation
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: a31             !< coefficient for Lund rotation
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: a32             !< coefficient for Lund rotation
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: a33             !< coefficient for Lund rotation
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: tu              !< Lagrangian time scale of u
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: tv              !< Lagrangian time scale of v
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: tw              !< Lagrangian time scale of w
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bux           !< filter function for u in x direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: buy           !< filter function for u in y direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: buz           !< filter function for u in z direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bvx           !< filter function for v in x direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bvy           !< filter function for v in y direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bvz           !< filter function for v in z direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bwx           !< filter function for w in y direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bwy           !< filter function for w in y direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: bwz           !< filter function for w in z direction
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fu_xz         !< velocity seed for u at xz plane
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fuo_xz        !< velocity seed for u at xz plane with new random number
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fu_yz         !< velocity seed for u at yz plane
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fuo_yz        !< velocity seed for u at yz plane with new random number
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fv_xz         !< velocity seed for v at xz plane
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fvo_xz        !< velocity seed for v at xz plane with new random number
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fv_yz         !< velocity seed for v at yz plane
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fvo_yz        !< velocity seed for v at yz plane with new random number
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fw_xz         !< velocity seed for w at xz plane
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fwo_xz        !< velocity seed for w at xz plane with new random number
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fw_yz         !< velocity seed for w at yz plane
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: fwo_yz        !< velocity seed for w at yz plane with new random number
-
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  displs_xz      !< displacement for MPI_GATHERV
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  recv_count_xz  !< receive count for MPI_GATHERV
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  displs_yz      !< displacement for MPI_GATHERV
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  recv_count_yz  !< receive count for MPI_GATHERV
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nux            !< length scale of u in x direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nuy            !< length scale of u in y direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nuz            !< length scale of u in z direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nvx            !< length scale of v in x direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nvy            !< length scale of v in y direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nvz            !< length scale of v in z direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nwx            !< length scale of w in x direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nwy            !< length scale of w in y direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nwz            !< length scale of w in z direction (in gp)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  seed           !< seed of random number for rn-generator
+
+    REAL(wp) ::  cosmo_ref = 10.0_wp      !< height of first vertical grid level in mesoscale model, used for calculation of scaling parameters
+    REAL(wp) ::  dt_stg_adjust = 300.0_wp !< time interval for adjusting turbulence statistics
+    REAL(wp) ::  dt_stg_call = 5.0_wp     !< time interval for calling synthetic turbulence generator
+    REAL(wp) ::  mc_factor                !< mass flux correction factor
+    REAL(wp) ::  scale_l                  !< scaling parameter used for turbulence parametrization - Obukhov length
+    REAL(wp) ::  scale_us                 !< scaling parameter used for turbulence parametrization - friction velocity
+    REAL(wp) ::  scale_wm                 !< scaling parameter used for turbulence parametrization - momentum scale  
+    REAL(wp) ::  time_stg_adjust = 0.0_wp !< time counter for adjusting turbulence information   
+    REAL(wp) ::  time_stg_call = 0.0_wp   !< time counter for calling generator   
+    
+    
+    REAL(wp),DIMENSION(:), ALLOCATABLE ::  r11              !< Reynolds parameter
+    REAL(wp),DIMENSION(:), ALLOCATABLE ::  r21              !< Reynolds parameter
+    REAL(wp),DIMENSION(:), ALLOCATABLE ::  r22              !< Reynolds parameter
+    REAL(wp),DIMENSION(:), ALLOCATABLE ::  r31              !< Reynolds parameter
+    REAL(wp),DIMENSION(:), ALLOCATABLE ::  r32              !< Reynolds parameter
+    REAL(wp),DIMENSION(:), ALLOCATABLE ::  r33              !< Reynolds parameter
+    
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  a11             !< coefficient for Lund rotation
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  a21             !< coefficient for Lund rotation
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  a22             !< coefficient for Lund rotation
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  a31             !< coefficient for Lund rotation
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  a32             !< coefficient for Lund rotation
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  a33             !< coefficient for Lund rotation
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tu              !< Lagrangian time scale of u
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tv              !< Lagrangian time scale of v
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tw              !< Lagrangian time scale of w
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bux           !< filter function for u in x direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  buy           !< filter function for u in y direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  buz           !< filter function for u in z direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bvx           !< filter function for v in x direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bvy           !< filter function for v in y direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bvz           !< filter function for v in z direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bwx           !< filter function for w in y direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bwy           !< filter function for w in y direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  bwz           !< filter function for w in z direction
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fu_xz         !< velocity seed for u at xz plane
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fuo_xz        !< velocity seed for u at xz plane with new random number
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fu_yz         !< velocity seed for u at yz plane
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fuo_yz        !< velocity seed for u at yz plane with new random number
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fv_xz         !< velocity seed for v at xz plane
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fvo_xz        !< velocity seed for v at xz plane with new random number
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fv_yz         !< velocity seed for v at yz plane
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fvo_yz        !< velocity seed for v at yz plane with new random number
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fw_xz         !< velocity seed for w at xz plane
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwo_xz        !< velocity seed for w at xz plane with new random number
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fw_yz         !< velocity seed for w at yz plane
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  fwo_yz        !< velocity seed for w at yz plane with new random number
+    
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  dist_xz     !< imposed disturbances at north/south boundary
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  dist_yz     !< imposed disturbances at north/south boundary
 
 !
 !-- PALM interfaces:
+!-- Adjust time and lenght scales, Reynolds stress, and filter functions
+    INTERFACE stg_adjust
+       MODULE PROCEDURE stg_adjust
+    END INTERFACE stg_adjust
+!
 !-- Input parameter checks to be done in check_parameters
     INTERFACE stg_check_parameters
@@ -319,11 +353,12 @@
 !
 !-- Public interfaces
-    PUBLIC  stg_check_parameters, stg_header, stg_init, stg_main, stg_parin,   &
-            stg_wrd_global, stg_rrd_global
+    PUBLIC  stg_adjust, stg_check_parameters, stg_header, stg_init, stg_main,  &
+            stg_parin, stg_rrd_global, stg_wrd_global
 
 !
 !-- Public variables
-    PUBLIC  id_stg_left, id_stg_north, id_stg_right, id_stg_south,             &
-            use_syn_turb_gen
+    PUBLIC  dt_stg_call, dt_stg_adjust, id_stg_left, id_stg_north,             &
+            id_stg_right, id_stg_south, parametrize_inflow_turbulence,         &
+            time_stg_adjust, time_stg_call, use_syn_turb_gen
 
 
@@ -376,5 +411,6 @@
              message_string = 'Using synthetic turbulence generator ' //       &
                               'requires %initializing_actions = '         //   &
-                              '"set_constant_profiles" or "read_restart_data"'
+                              '"set_constant_profiles" or "read_restart_data"' //&
+                              ', if not offline nesting is applied.'
              CALL message( 'stg_check_parameters', 'PA0015', 1, 2, 0, 6, 0 )
           ENDIF
@@ -382,10 +418,12 @@
           IF ( bc_lr /= 'dirichlet/radiation' )  THEN
              message_string = 'Using synthetic turbulence generator ' //       &
-                              'requires &bc_lr = "dirichlet/radiation"'
+                              'requires &bc_lr = "dirichlet/radiation", ' //   &
+                              'if not offline nesting is applied.'
              CALL message( 'stg_check_parameters', 'PA0035', 1, 2, 0, 6, 0 )
           ENDIF
           IF ( bc_ns /= 'cyclic' )  THEN
              message_string = 'Using synthetic turbulence generator ' //       &
-                              'requires &bc_ns = "cyclic"'
+                              'requires &bc_ns = "cyclic", ' //               &
+                              'if not offline nesting is applied.'
              CALL message( 'stg_check_parameters', 'PA0037', 1, 2, 0, 6, 0 )
           ENDIF
@@ -425,9 +463,18 @@
        WRITE( io, 3 )
     ENDIF
+    
+    IF ( parametrize_inflow_turbulence )  THEN
+       WRITE( io, 4 ) dt_stg_adjust
+    ELSE
+       WRITE( io, 5 )
+    ENDIF
 
 1   FORMAT (//' Synthetic turbulence generator information:'/                  &
               ' ------------------------------------------'/)
-2   FORMAT ('    synthetic turbulence generator switched on')
-3   FORMAT ('    synthetic turbulence generator switched off')
+2   FORMAT ('    synthetic turbulence generator is switched on')
+3   FORMAT ('    synthetic turbulence generator is switched off')
+4   FORMAT ('    imposed turbulence statistics are parametrized and ' \\       &
+            'ajdusted to boundary-layer development each ', F8.2, ' s' )
+5   FORMAT ('    imposed turbulence is read from file' )
 
  END SUBROUTINE stg_header
@@ -443,5 +490,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, ddzw, u_init, v_init, zu, zw
+        ONLY:  dzw, ddzw, u_init, v_init, zu
 
     USE control_parameters,                                                    &
@@ -460,5 +507,5 @@
     IMPLICIT NONE
 
-    LOGICAL ::  file_stg_exist = .FALSE. !< flag indication whether parameter file for Reynolds stress and length scales exist
+    LOGICAL ::  file_stg_exist = .FALSE. !< flag indicating whether parameter file for Reynolds stress and length scales exist
 
 #if defined( __parallel )
@@ -484,5 +531,4 @@
     REAL(wp) :: d21     !< vertical interpolation for a21
     REAL(wp) :: d22     !< vertical interpolation for a22
-    REAL(wp) :: dum_exp !< dummy variable used for exponential vertical decrease of turbulent length scales
     REAL(wp) :: luy     !< length scale for u in y direction
     REAL(wp) :: luz     !< length scale for u in z direction
@@ -494,16 +540,4 @@
     REAL(wp) :: zz      !< height
 
-    REAL(wp) :: length_scale_surface !< typical length scale
-    REAL(wp) :: r_ii_0               !< correction factor
-    REAL(wp) :: time_scale           !< typical time scale
-    REAL(wp) :: length_scale_z       !< typical length scale
-
-    REAL(wp),DIMENSION(nzb:nzt+1) :: r11  !< Reynolds parameter
-    REAL(wp),DIMENSION(nzb:nzt+1) :: r21  !< Reynolds parameter
-    REAL(wp),DIMENSION(nzb:nzt+1) :: r22  !< Reynolds parameter
-    REAL(wp),DIMENSION(nzb:nzt+1) :: r31  !< Reynolds parameter
-    REAL(wp),DIMENSION(nzb:nzt+1) :: r32  !< Reynolds parameter
-    REAL(wp),DIMENSION(nzb:nzt+1) :: r33  !< Reynolds parameter
-
 
 #if defined( __parallel )
@@ -512,14 +546,4 @@
 
     CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
-
-    IF ( .NOT. ALLOCATED( mean_inflow_profiles ) )                             &
-       ALLOCATE( mean_inflow_profiles(nzb:nzt+1,1:num_mean_inflow_profiles) )
-
-    ALLOCATE ( a11(nzb:nzt+1), a21(nzb:nzt+1), a22(nzb:nzt+1),                 &
-               a31(nzb:nzt+1), a32(nzb:nzt+1), a33(nzb:nzt+1),                 &
-               nux(nzb:nzt+1), nuy(nzb:nzt+1), nuz(nzb:nzt+1),                 &
-               nvx(nzb:nzt+1), nvy(nzb:nzt+1), nvz(nzb:nzt+1),                 &
-               nwx(nzb:nzt+1), nwy(nzb:nzt+1), nwz(nzb:nzt+1),                 &
-               tu(nzb:nzt+1),  tv(nzb:nzt+1),  tw(nzb:nzt+1)   )
 
 #if defined( __parallel )
@@ -615,5 +639,26 @@
     ENDDO
     CALL RANDOM_SEED(put=seed)
-
+!
+!-- Allocate required arrays
+!-- mean_inflow profiles must not be allocated in offline nesting
+    IF ( .NOT. nesting_offline  .AND.  .NOT.  child_domain )  THEN 
+       IF ( .NOT. ALLOCATED( mean_inflow_profiles ) )                          &
+          ALLOCATE( mean_inflow_profiles(nzb:nzt+1,1:num_mean_inflow_profiles) )
+    ENDIF
+
+    ALLOCATE ( a11(nzb:nzt+1), a21(nzb:nzt+1), a22(nzb:nzt+1),                 &
+               a31(nzb:nzt+1), a32(nzb:nzt+1), a33(nzb:nzt+1),                 &
+               nux(nzb:nzt+1), nuy(nzb:nzt+1), nuz(nzb:nzt+1),                 &
+               nvx(nzb:nzt+1), nvy(nzb:nzt+1), nvz(nzb:nzt+1),                 &
+               nwx(nzb:nzt+1), nwy(nzb:nzt+1), nwz(nzb:nzt+1),                 &
+               r11(nzb:nzt+1), r21(nzb:nzt+1), r22(nzb:nzt+1),                 &
+               r31(nzb:nzt+1), r32(nzb:nzt+1), r33(nzb:nzt+1),                 &
+               tu(nzb:nzt+1),  tv(nzb:nzt+1),  tw(nzb:nzt+1)   )
+               
+    ALLOCATE ( dist_xz(nzb:nzt+1,nxlg:nxrg,3) )
+    ALLOCATE ( dist_yz(nzb:nzt+1,nysg:nyng,3) )
+    dist_xz = 0.0_wp
+    dist_yz = 0.0_wp
+!
 !-- Read inflow profile
 !-- Height levels of profiles in input profile is as follows:
@@ -669,80 +714,34 @@
        
        CLOSE( 90 )
-
+!
+!--    Calculate coefficient matrix from Reynolds stress tensor  
+!--    (Lund rotation)
+       CALL calc_coeff_matrix
+!
+!-- No information about turbulence and its length scales are available.
+!-- Instead, parametrize turbulence which is imposed at the boundaries. 
+!-- Set flag which indicates that turbulence is parametrized, which is done 
+!-- later when energy-balance models are already initialized. This is 
+!-- because the STG needs information about surface properties such as 
+!-- roughness to build 'realistic' turbulence profiles. 
     ELSE
 !
-!--    Set-up default turbulent length scales. From the numerical point of
-!--    view the imposed perturbations should not be immediately dissipated
-!--    by the numerics. The numerical dissipation, however, acts on scales
-!--    up to 8 x the grid spacing. For this reason, set the turbulence 
-!--    length scale to 8 time the grid spacing. Further, above the boundary
-!--    layer height, set turbulence lenght scales to zero (equivalent to not
-!--    imposing any perturbations) in order to save computational costs. 
-!--    Typical length (time) scales of 100 m (s) should be a good compromise
-!--    between all stratrifications. Near-surface variances are fixed to
-!--    0.1 m2/s2, vertical fluxes are one order of magnitude smaller.
-!--    Vertical fluxes
-       length_scale_surface = 100.0_wp
-       r_ii_0               = 0.1_wp
-       time_scale           = 100.0_wp
-       DO  k = nzb+1, nzt+1
-          dum_exp        = MERGE( -zu(k) / ( 0.3* zu(nzt) ),                   &
-                                  0.0_wp,                                      &
-                                  zu(k) > 0.3 * zu(nzt)                        &
-                                )
-          length_scale_z = 8.0_wp * MIN( dx, dy, dzw(k) )
-          
-!           IF ( zu(k) > zi_richardson )  
-
-          nux(k) = MAX( INT( length_scale_z * ddx     ), 1 )
-          nuy(k) = MAX( INT( length_scale_z * ddy     ), 1 )
-          nuz(k) = MAX( INT( length_scale_z * ddzw(k) ), 1 )
-          nvx(k) = MAX( INT( length_scale_z * ddx     ), 1 )
-          nvy(k) = MAX( INT( length_scale_z * ddy     ), 1 )
-          nvz(k) = MAX( INT( length_scale_z * ddzw(k) ), 1 )
-          nwx(k) = MAX( INT( length_scale_z * ddx     ), 1 )
-          nwy(k) = MAX( INT( length_scale_z * ddy     ), 1 )
-          nwz(k) = MAX( INT( length_scale_z * ddzw(k) ), 1 )
-
-          r11(k) = r_ii_0 * EXP( dum_exp )
-          r22(k) = r_ii_0 * EXP( dum_exp )
-          r33(k) = r_ii_0 * EXP( dum_exp )
-
-          r21(k) = 0.1_wp * r_ii_0 * EXP( dum_exp )
-          r31(k) = 0.1_wp * r_ii_0 * EXP( dum_exp )
-          r32(k) = 0.1_wp * r_ii_0 * EXP( dum_exp )
-
-          tu(k)  = time_scale
-          tv(k)  = time_scale
-          tw(k)  = time_scale
-
-       ENDDO
-       
-       nux(nzb) = nux(nzb+1)
-       nuy(nzb) = nuy(nzb+1)
-       nuz(nzb) = nuz(nzb+1)
-       nvx(nzb) = nvx(nzb+1)
-       nvy(nzb) = nvy(nzb+1)
-       nvz(nzb) = nvz(nzb+1)
-       nwx(nzb) = nwx(nzb+1)
-       nwy(nzb) = nwy(nzb+1)
-       nwz(nzb) = nwz(nzb+1)
-
-       r11(nzb) = r11(nzb+1)
-       r22(nzb) = r22(nzb+1)
-       r33(nzb) = r33(nzb+1)
-
-       r21(nzb) = r11(nzb+1)
-       r31(nzb) = r31(nzb+1)
-       r32(nzb) = r32(nzb+1)
-
-       tu(nzb)  = time_scale
-       tv(nzb)  = time_scale
-       tw(nzb)  = time_scale
-
+!--    Set flag indicating that turbulence is parametrized
+       parametrize_inflow_turbulence = .TRUE.
+!
+!--    Determine boundary-layer depth, which is used to initialize lenght 
+!--    scales
+       CALL calc_scaling_variables
+!
+!--    Initialize lenght and time scales, which in turn are used
+!--    to initialize the filter functions.
+       CALL calc_length_and_time_scale
+            
     ENDIF
 
 !
-!-- Assign initial profiles
+!-- Assign initial profiles. Note, this is only required if turbulent
+!-- inflow from the left is desired, not in case of any of the 
+!-- nesting (offline or self nesting) approaches.
     IF ( .NOT. nesting_offline  .AND.  .NOT.  child_domain )  THEN 
        u_init = mean_inflow_profiles(:,1)
@@ -751,56 +750,5 @@
        e_init = MAXVAL( mean_inflow_profiles(:,5) )
     ENDIF
-!
-!-- Calculate coefficient matrix from Reynolds stress tensor (Lund rotation)
-    DO  k = nzb, nzt+1
-       IF ( r11(k) > 0.0_wp )  THEN
-          a11(k) = SQRT( r11(k) )
-          a21(k) = r21(k) / a11(k)
-       ELSE
-          a11(k) = 0.0_wp
-          a21(k) = 0.0_wp
-       ENDIF
-
-       a22(k) = r22(k) - a21(k)**2
-       IF ( a22(k) > 0.0_wp )  THEN
-          a22(k) = SQRT( a22(k) )
-       ELSE
-          a22(k) = 0.0_wp
-       ENDIF
-
-!
-!--    a31, a32, a33 must be calculated with interpolated a11, a21, a22 (d11,
-!--    d21, d22) because of different vertical grid
-       IF ( k .le. nzt )  THEN
-          d11 = 0.5_wp * ( r11(k) + r11(k+1) )
-          IF ( d11 > 0.0_wp )  THEN
-             d11 = SQRT( d11 )
-             d21 = ( 0.5_wp * ( r21(k) + r21(k+1) ) ) / d11
-             a31(k) = r31(k) / d11
-          ELSE
-             d21 = 0.0_wp
-             a31(k) = 0.0_wp
-          ENDIF
-
-          d22 = 0.5_wp * ( r22(k) + r22(k+1) ) - d21 ** 2
-          IF ( d22 > 0.0_wp )  THEN
-             a32(k) = ( r32(k) - d21 * a31(k) ) / SQRT( d22 )
-          ELSE
-             a32(k) = 0.0_wp
-          ENDIF
-
-          a33(k) = r33(k) - a31(k) ** 2 - a32(k) ** 2
-          IF ( a33(k) > 0.0_wp )  THEN
-             a33(k) = SQRT( a33(k) )
-          ELSE
-             a33(k) = 0.0_wp
-          ENDIF
-       ELSE
-          a31(k) = a31(k-1)
-          a32(k) = a32(k-1)
-          a33(k) = a33(k-1)
-       ENDIF
-
-    ENDDO
+    
 !
 !-- Define the size of the filter functions and allocate them.
@@ -961,5 +909,5 @@
     ENDDO
 
-END SUBROUTINE stg_filter_func
+ END SUBROUTINE stg_filter_func
 
 
@@ -977,5 +925,5 @@
 
 
-    NAMELIST /stg_par/   use_syn_turb_gen
+    NAMELIST /stg_par/  dt_stg_adjust, dt_stg_call, use_syn_turb_gen
 
     line = ' '
@@ -1108,14 +1056,9 @@
     REAL(wp) :: volume_flow_l   !< local mass flux through lateral boundary
 
-    REAL(wp), DIMENSION(nzb:nzt+1,nxlg:nxrg,5) :: dist_xz !< imposed disturbances at north/south boundary
-    REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,5) :: dist_yz !< imposed disturbances at left/right boundary
-
-
     CALL  cpu_log( log_point(57), 'synthetic_turbulence_gen', 'start' )
 
 !
 !-- Calculate time step which is needed for filter functions
-    dt_stg = dt_3d * weight_substep(intermediate_timestep_count)
-
+    dt_stg = MAX( dt_3d, dt_stg_call ) !* weight_substep(intermediate_timestep_count)
 !
 !-- Initial value of fu, fv, fw
@@ -1145,4 +1088,5 @@
        velocity_seed_initialized = .TRUE.
     ENDIF
+    
 !
 !-- New set of fu, fv, fw
@@ -1150,27 +1094,28 @@
     CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fvo_yz, id_stg_left )
     CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fwo_yz, id_stg_left )
-
+    
     IF ( nesting_offline  .OR.  ( child_domain .AND.  rans_mode_parent         &
-                             .AND.  .NOT.  rans_mode ) )  THEN
-!
-!--       Generate turbulence at right boundary
-          CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fuo_yz, id_stg_right )
-          CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fvo_yz, id_stg_right )
-          CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fwo_yz, id_stg_right )
-!
-!--       Generate turbulence at north boundary
-          CALL stg_generate_seed_xz( nux, nuz, bux, buz, fuo_xz, id_stg_north )
-          CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fvo_xz, id_stg_north )
-          CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fwo_xz, id_stg_north )
-!
-!--       Generate turbulence at south boundary
-          CALL stg_generate_seed_xz( nux, nuz, bux, buz, fuo_xz, id_stg_south )
-          CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fvo_xz, id_stg_south )
-          CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fwo_xz, id_stg_south )
+                          .AND.  .NOT.  rans_mode ) )  THEN
+!
+!--    Generate turbulence at right boundary
+       CALL stg_generate_seed_yz( nuy, nuz, buy, buz, fuo_yz, id_stg_right )
+       CALL stg_generate_seed_yz( nvy, nvz, bvy, bvz, fvo_yz, id_stg_right )
+       CALL stg_generate_seed_yz( nwy, nwz, bwy, bwz, fwo_yz, id_stg_right )
+!
+!--    Generate turbulence at north boundary
+       CALL stg_generate_seed_xz( nux, nuz, bux, buz, fuo_xz, id_stg_north )
+       CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fvo_xz, id_stg_north )
+       CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fwo_xz, id_stg_north )
+!
+!--    Generate turbulence at south boundary
+       CALL stg_generate_seed_xz( nux, nuz, bux, buz, fuo_xz, id_stg_south )
+       CALL stg_generate_seed_xz( nvx, nvz, bvx, bvz, fvo_xz, id_stg_south )
+       CALL stg_generate_seed_xz( nwx, nwz, bwx, bwz, fwo_xz, id_stg_south )
     ENDIF
+    
 !
 !-- Turbulence generation at left and or right boundary
     IF ( myidx == id_stg_left  .OR.  myidx == id_stg_right )  THEN
-
+    
        DO  j = nysg, nyng
           DO  k = nzb, nzt + 1
@@ -1180,5 +1125,5 @@
                 fu_yz(k,j) = fuo_yz(k,j)
              ELSE
-                fu_yz(k,j) = fu_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tu(k) ) +     &
+                fu_yz(k,j) = fu_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tu(k) ) + &
                          fuo_yz(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tu(k) ) )
              ENDIF
@@ -1187,5 +1132,5 @@
                 fv_yz(k,j) = fvo_yz(k,j)
              ELSE
-                fv_yz(k,j) = fv_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tv(k) ) +     &
+                fv_yz(k,j) = fv_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tv(k) ) + &
                          fvo_yz(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tv(k) ) )
              ENDIF
@@ -1194,5 +1139,5 @@
                 fw_yz(k,j) = fwo_yz(k,j)
              ELSE
-                fw_yz(k,j) = fw_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tw(k) ) +     &
+                fw_yz(k,j) = fw_yz(k,j) * EXP( -pi * dt_stg * 0.5_wp / tw(k) ) + &
                          fwo_yz(k,j) * SQRT( 1.0_wp - EXP( -pi * dt_stg / tw(k) ) )
              ENDIF
